import 'vite/dynamic-import-polyfill';
import 'dot-ream/templates/global-imports.js';
import { reactive } from 'vue';
import { g as getLoadPath, c as createRouter, f as createWebHistory } from './index-daa12a84.js';
import { clientRoutes } from 'dot-ream/templates/shared-exports.js';
import { c as createApp } from './create-app-bc282a05.js';
import { callAsync } from 'dot-ream/templates/enhance-app.js';

function mitt(n){return {all:n=n||new Map,on:function(t,e){var i=n.get(t);i&&i.push(e)||n.set(t,[e]);},off:function(t,e){var i=n.get(t);i&&i.splice(i.indexOf(e)>>>0,1);},emit:function(t,e){(n.get(t)||[]).slice().map(function(n){n(e);}),(n.get("*")||[]).slice().map(function(n){n(t,e);});}}}

const noop = () => {
};
const loadPageData = async (to, next = noop) => {
  if (!to.matched || to.matched.length === 0) {
    return next();
  }
  const initialState = window._ream.initialState;
  if (to.name === "404") {
    initialState.load[to.path] = {notFound: true};
    return next();
  }
  const components = to.matched.map((m) => m.components.default);
  const hasLoad = components.some((component) => component.$$load || component.$$preload);
  if (!hasLoad) {
    initialState.load[to.path] = {hasLoad: false};
    return next();
  }
  const fetchPage = async (next2) => {
    const result = {};
    for (const component of components) {
      if (component.$$load || component.$$preload) {
        const _result = await fetch(getLoadPath(to.path)).then((res) => {
          if (res.status === 404) {
            return {notFound: true};
          }
          return res.json();
        });
        Object.assign(result, _result);
        break;
      }
    }
    initialState.load[to.path] = result;
    next2(result.redirect ? result.redirect.url : void 0);
  };
  await fetchPage(next);
};
const getBeforeResolve = () => async function beforeResolve(to, from, next) {
  await loadPageData(to, next);
};

const scrollBehavior = (to, from, savedPosition) => {
  return new Promise((resolve) => {
    const handleScroll = () => {
      _ream.event.off("trigger-scroll", handleScroll);
      if (to.hash) {
        return resolve({
          el: to.hash
        });
      }
      if (savedPosition) {
        return resolve(savedPosition);
      }
      resolve({
        top: 0
      });
    };
    _ream.event.on("trigger-scroll", handleScroll);
  });
};

window._ream = {
  event: mitt()
};
async function start() {
  const router = createRouter({
    history: createWebHistory(),
    routes: clientRoutes,
    scrollBehavior
  });
  window._ream.router = router;
  await callAsync("extendRouter", {router});
  router.afterEach((to, from) => {
    let transition;
    for (const m of to.matched) {
      let {$$transition} = m.components.default;
      if (typeof $$transition === "function") {
        $$transition = $$transition(to, from);
      }
      if ($$transition != null) {
        transition = $$transition;
      }
    }
    to.meta.transition = transition;
  });
  const initialState = reactive(window.INITIAL_STATE);
  window._ream.initialState = initialState;
  const {app} = await createApp({
    router,
    initialState
  });
  await router.isReady();
  const instance = app.mount("#_ream", true);
  if (import.meta.env.DEV) {
    app._container._vnode = instance.$.vnode;
  }
  window._ream.app = app;
  window._ream.instance = instance;
  router.beforeResolve(getBeforeResolve());
}
start();
