import * as vue from 'vue';
import { ComponentPublicInstance, AsyncComponentLoader, ComputedRef } from 'vue';
export { createSSRApp } from 'vue';
import { R as Router, L as LoadResultNormalized } from '../load-1f537ab8';
export { G as GetStaticPaths, H as HTMLResult, d as Head, e as HeadAttrs, f as HeadClient, g as HeadObject, h as HeadObjectPlain, i as HeadTag, c as Load, P as Preload, b as RouterView, j as createHead, k as injectHead, r as renderHeadToString, l as useHead, u as useRoute, a as useRouter } from '../load-1f537ab8';

declare const AppComponent: vue.DefineComponent<Readonly<{
    Component?: any;
}>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>[] | undefined, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, Record<string, any>, string, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<{
    Component: any;
} & {}>, {
    Component: any;
}>;

declare const ErrorComponent: vue.DefineComponent<{}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}> | undefined, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, vue.EmitsOptions, string, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<{} & {}>, {}>;

declare const NotFoundComponent: {
    name: string;
    setup(): () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>;
};

declare const RouterLink: vue.DefineComponent<{}, {}, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, vue.EmitsOptions, string, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<{} & {}>, {}>;

declare type ExtendApp = (context: {
    router: Router;
    app: ComponentPublicInstance;
    initialState: any;
}) => void | Promise<void>;
declare type ExtendRouter = (context: {
    router: Router;
}) => void | Promise<void>;

declare const ClientOnly: vue.DefineComponent<{}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>[] | null, {}, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, vue.EmitsOptions, string, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<{} & {}>, {}>;
declare const defineClientComponent: (load: AsyncComponentLoader) => {
    name: string;
    setup(): () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>;
};

declare const useInitialState: <TInitialState extends object = {
    [k: string]: any;
}, TProps = any>() => ComputedRef<TInitialState & {
    load: {
        [pathname: string]: LoadResultNormalized<TProps>;
    };
}>;
declare const useLoadResult: <TProps = any>() => LoadResultNormalized<TProps>;
declare const useServerError: () => {
    status: number;
    message?: string;
} | undefined;
declare const usePageProps: <TData = any>() => ComputedRef<TData>;
/**
 * Get the route path without trailing slash
 */
declare const useRoutePath: () => ComputedRef<string>;

export { AppComponent, ClientOnly, ErrorComponent, ExtendApp, ExtendRouter, NotFoundComponent, RouterLink, defineClientComponent, useInitialState, useLoadResult, usePageProps, useRoutePath, useServerError };
