import 'dot-ream/templates/global-imports.js';
import nodeFetch from 'node-fetch';
import { r as renderHeadToString, c as createRouter, a as createMemoryHistory } from './index-daa12a84.js';
import { c as createApp } from './create-app-bc282a05.js';
import { clientRoutes } from 'dot-ream/templates/shared-exports.js';
export { ErrorComponent, clientRoutes } from 'dot-ream/templates/shared-exports.js';
import { serverRoutes } from 'dot-ream/templates/server-exports.js';
export { serverRoutes } from 'dot-ream/templates/server-exports.js';
import * as enhanceApp_js from 'dot-ream/templates/enhance-app.js';
export { enhanceApp_js as enhanceApp };
import * as enhanceServer_js from 'dot-ream/templates/enhance-server.js';
export { enhanceServer_js as enhanceServer };
import 'vue';

const ENV = process.env;
globalThis.fetch = function(url, opts) {
  if (url && url[0] === "/") {
    url = `http://localhost:${ENV.PORT}${url}`;
  }
  return nodeFetch(url, opts);
};
async function render(context) {
  const {app} = await createApp(context);
  return app;
}
function renderHead(app) {
  return renderHeadToString(app.config.globalProperties.$head);
}
function createClientRouter() {
  const router = createRouter({
    history: createMemoryHistory(),
    routes: clientRoutes
  });
  return router;
}
function createServerRouter() {
  const router = createRouter({
    history: createMemoryHistory(),
    routes: serverRoutes
  });
  return router;
}

export { createClientRouter, createServerRouter, render, renderHead };
